<script lang="ts">
  import { createEventDispatcher, onMount } from 'svelte';

  export let size: string = '50px';
  export let play: Nullable<boolean> = false;

  const dispatch = createEventDispatcher();
  let timeline: GSAPTimeline;

  onMount(async () => {
    const [gsapModule] = await Promise.all([import('gsap/all')]);
    const gsap = gsapModule.gsap;

    const bgTween = gsap.from('.circle', {
      delay: 0.8,
      duration: 0.5,
      scale: 0,
      ease: 'back.out',
    });

    const crossTween = gsap.from('.cross', {
      // delay: 0.2,
      duration: 0.2,
      scale: 0,
      rotation: -90,
    });

    timeline = gsap.timeline({ paused: true });
    timeline.add(bgTween).add(crossTween);
  });

  $: play && timeline?.restart();

  const onClick = () => {
    timeline.pause(0);
    dispatch('close');
  };
</script>

<div
  class="close-wrapper {$$props.class}"
  style="width: {size}; height: {size}; visibility:{play ? 'visible' : 'hidden'}">
  <button on:click={onClick}>
    <span class="circle" />
    <img
      src="$lib/svgs/cross.svg"
      class="cross"
      alt="close-cross" />
  </button>
</div>

<style>
  .close-wrapper {
    position: absolute;
    top: var(--content-margin);
    right: var(--content-margin);
  }

  button {
    all: unset;
    width: 100%;
    height: 100%;
    cursor: pointer;
  }

  .circle {
    position: absolute;
    top: 0;
    width: 100%;
    height: 100%;
    border-radius: 50%;
    background-color: white;
  }

  .cross {
    position: absolute;
    top: 50%; /* Adjust the vertical position of the cross */
    left: 50%; /* Adjust the horizontal position of the cross */
    width: 60%;
    height: 60%;
    transform: translate(-50%, -50%); /* Center the cross */
  }
</style>
